 renoise.tool():add_keybinding {
  name = "Global:Tools:Minimize All Devices in Track",
  invoke = function() minimize_all_devices_in_track() end
}

 renoise.tool():add_keybinding {
  name = "Global:Tools:Maxmize All Devices in Track",
  invoke = function() maximize_all_devices_in_track() end
}

 renoise.tool():add_keybinding {
  name = "Global:Tools:Minimize All Devices in Song",
  invoke = function() minimize_all_devices_in_song() end
}

 renoise.tool():add_keybinding {
  name = "Global:Tools:Maximize All Devices in Song",
  invoke = function() maximize_all_devices_in_song() end
}


------------------------------------------------------------------------
function minimize_all_devices_in_track()

local current_track = renoise.song().selected_track_index
local number_of_devices = #renoise.song().tracks[current_track].devices

  for a = 2,number_of_devices do
    renoise.song().tracks[current_track].devices[a].is_maximized = false
  end
end

------------------------------------------------------------------------
function maximize_all_devices_in_track()

local current_track = renoise.song().selected_track_index
local number_of_devices = #renoise.song().tracks[current_track].devices

  for a = 2,number_of_devices do
    renoise.song().tracks[current_track].devices[a].is_maximized = true
  end
end

------------------------------------------------------------------------

function minimize_all_devices_in_song()

local number_of_tracks_in_song = #renoise.song().tracks

for b = 1, number_of_tracks_in_song do
   local current_devices = #renoise.song().tracks[b].devices
   
    if current_devices > 1 then 
      for a = 2, current_devices   do
        renoise.song().tracks[b].devices[a].is_maximized = false 
      
          end
      end
   end
end
-------------------------------------------------------------------------

function maximize_all_devices_in_song()

local number_of_tracks_in_song = #renoise.song().tracks

for b = 1, number_of_tracks_in_song do
  local current_devices = #renoise.song().tracks[b].devices
   
    if current_devices > 1 then 
      for a = 2, current_devices   do
        renoise.song().tracks[b].devices[a].is_maximized = true 
      
          end
      end
   end
end
